package jp.denpa.tomy.opengl_es.wrap;


import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLSurfaceView;
import android.opengl.GLUtils;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

//import jp.denpa.tomy.games.MyView;
//import jp.denpa.tomy.games.R;
import jp.denpa.tomy.games.*;

//OpenGL の　Rendererに関するクラス　メインループもここでする（←？）

public class MainRenderer implements GLSurfaceView.Renderer{


//	enum FlameNo{
//		START_INIT,
//		START_MAIN,
//		MENU_INIT,   	//メニュー準備
//		MENU_MAIN,   	//メニュー処理
//		GAME_INIT,   	//ゲーム準備
//		GAME_MAIN,		//ゲーム処理
//		RESULT_INIT,	//ゲーム終了時の得点表示
//		RESULT_MAIN,	//ゲーム終了時の得点表示
//	}
//	static FlameNo gameFlg = FlameNo.START_INIT;        //ゲームフラグ

//Taskの使用テスト----------------------------------------------------------------------------
	final int START 	=0;
	final int GAME 		=1;
	final int RESULT 	=2;

	Task[] tasks = new Task[3];



	int State = START;
//-------------------------------------------------------------------------------------------

	private Context context;



	public static int screenW;           //スクリーン座標
	public static int screenH;




	public  MainRenderer(Context ctext){

		context=ctext;
	}



	//サーフェイス作成時の処理(サーフェイスが生成される際・または再生成される際に呼ばれる)
	@Override
	public void onSurfaceCreated(GL10 gl10, EGLConfig eglconfing){
//Taskの使用テスト(本来はここでやらない予定)------------------------------------------------------------------

		tasks[START] = new Start();
//		tasks[GAME]  = new Game();
//		tasks[RESULT]= new Result();
		tasks[START].Init(gl10, context);
//------------------------------------------------------------------------------------------
//		//⑦背景色
//		gl10.glClearColor(1.0f,1.0f,1.0f,1.0f);
//	    // ディザを無効化
//	    gl10.glDisable(GL10.GL_DITHER);
//	    // 深度テストを有効に
//	    gl10.glEnable(GL10.GL_DEPTH_TEST);
//	 	//テクスチャ機能ON
//	  	gl10.glEnable(GL10.GL_TEXTURE_2D);
//	    //透明可能に
//	  	gl10.glEnable(GL10.GL_ALPHA_TEST);
//	   	//ブレンド可能に
//	   	gl10.glEnable(GL10.GL_BLEND);
//	  	//色のブレンド方法
//	  	gl10.glBlendFunc(GL10.GL_SRC_ALPHA,GL10.GL_ONE_MINUS_SRC_ALPHA);
//
//		tex1.LoadTexture(gl10, context.getResources(), R.drawable.image_512);
//		tex1.SetTex();
//
//		tex2.LoadTexture(gl10, context.getResources(), R.drawable.image_128);
//	  	tex2.SetTex();
//
	}

	//画面上のどの領域を使用するかの設定、あとポリゴン色とかの設定(サーフェイスのサイズ変更時に呼ばれる)
	@Override
	public void onSurfaceChanged(GL10 gl10, int w,int h ){
//一応の座標系設定（保険）--------------------------------------------------------------------
		//ビューポート変換
		gl10.glViewport(0,0,MainRenderer.screenW,MainRenderer.screenH);

		//投影変換
		gl10.glMatrixMode(GL10.GL_PROJECTION);
		gl10.glLoadIdentity();
		gl10.glOrthof(0,MainRenderer.screenW,-MainRenderer.screenH,0 , -10,10);	//座標系の指定（最重要:左上原点Wndow座標系指定(ニア、ファーは０にして２D専用にしている)）
//--------------------------------------------------------------------------------------------
		screenW = w;
		screenH = h;


	}


	//毎フレーム描画処理
	@Override
	public void onDrawFrame(GL10 gl10){
		//背景塗りつぶし----------------------------------
		gl10.glClearColor(1.0f, 0.5f, 0.5f, 1.0f);
		gl10.glClear(GL10.GL_COLOR_BUFFER_BIT);
		//end---------------------------------------------


		// テクスチャを使うポリゴンと、使わないポリゴンとの描画を分けて行う
		//GL2DVertexを継承したクラス(実際の処理＝画像の移動・回転・拡大とか)を用意する？

		// テクスチャ有りポリゴン描画開始-----------------
		gl10.glEnable(GL10.GL_TEXTURE_2D);
//Taskの使用テスト-------------------------------------------------------------------------
		tasks[START].Update();
		tasks[START].Draw();
//-----------------------------------------------------------------------------------------


		gl10.glDisable(GL10.GL_TEXTURE_2D);
		// テクスチャ有りポリゴン描画終了-----------------

		// テクスチャ無しポリゴン描画開始-----------------

//		test2.center=new Vector2(300,300);
//		test2.size=new Vector2(300,200);
//
//		//tex2.SetTex();
//		test2.SetUV(1, 1, 1, 1, false);
//		test2.SetPos();
//
//		test2.Draw(null);
		// テクスチャ無しポリゴン描画終了-----------------

	}
}

